#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cellule.h"
#include "liste.h"

list* creerListe()
{
	list* l = (list*)malloc(sizeof(list));
	l->debut = NULL;
	return l;
}

void detruireListe(list* l)
{
	if(l != NULL && l->debut != NULL)
	{
		cellule *precedent = l->debut;
		cellule *suivant = l->debut->next;
		while(precedent != NULL)
		{
			free(precedent);
			precedent = suivant;
			if(precedent != NULL)
				suivant = precedent->next;
		}	
	}
	free(l);
	
}

void inserer(cellule* c, list* l)
{
     if(c != NULL)
     {
	if(l == NULL || l->debut == NULL)
	{
		l->debut = c;
	}
	else
	{
		cellule *suivant = l->debut;
		l->debut = c;
		c->next = suivant;
		suivant->last = c;
	}
     }
}

cellule* rechercher(const char* str, list* l)
{
	if(l != NULL && l->debut != NULL)
	{
		cellule* precedent = l->debut;
		while(precedent != NULL && strcmp(precedent->mot , str) != 0)
		{
			precedent = precedent->next;
		}
		return precedent;	
	}
	return NULL;
}

void supprimer(cellule* c, list* l)
{
    if(c != NULL)
    {
	if(c->last != NULL)
		c->last->next = c->next;
	else
		l->debut = c->next;
	if(c->next != NULL)
		c->next->last = c->last;
	free(c);
    }
}
