#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <string.h>
#include <sys/stat.h>
#include <time.h>
#include "cellule.h"
#include "liste.h"
#include "outilsListe.h"
#include "tableHachage.h"
#include "outilsTableHachage.h"


void question4()
{
	list* l = creerListe();
	char var[50];
	cellule* c = NULL;
	while(strcmp(var,"Q") != 0)
	{
	  printf("Tapez un mot qui sera ajouter a la liste :\n");
	  scanf("%s",var);
	  c = creerCellule(var);
	  inserer(c,l);
	  afficherListe(l);
	  printf("test si 'Bonjour' est dans la liste :\n");
	  
	  cellule* res = rechercher("Bonjour", l);
	  if(res != NULL)
	      printf("Bonjour a ete trouver !\n");
	  else
	      printf("Bonjour n'a pas ete trouver !\n");
	  
	  printf("Supretion du mot bonjour si il existe.\n");
	  supprimer(res,l);
	  afficherListe(l);
	}
	
	
	detruireListe(l);
}

void question5()
{
	char *T_FILE = malloc(sizeof(char)*256);//  <===============

	
        FILE * pFile;
        pFile = fopen ("texte1.txt","r");
        if (pFile==NULL)
        {
                printf("Erreur lors de l'ouverture du fichier\n");
                exit(EXIT_FAILURE);
        }
        
	


	cellule* c;
	cellule* res;
	list* l = creerListe();        
   
        //rechercher un caracter
        while(fscanf(pFile, "%s", T_FILE) != EOF)
        {	
                
		res = rechercher(T_FILE, l);
		if(res == NULL)
		{
		    c = creerCellule(T_FILE);
		    inserer(c,l);
		}
        }
	
	fclose (pFile);
	printf("Nombre d'élément dans la Liste : %d\n",compterListe(l));
}

void question6()
{
	char *T_FILE = malloc(sizeof(char)*256);//  <===============
    
	char **Fichier = malloc(sizeof(char*)*6);
	int u;
	for(u = 0; u < 6;u++)
	  Fichier[u] = malloc(sizeof(char)*60);
	
	Fichier[0] = "texte1.txt";
	Fichier[1] = "texte2.txt";
	Fichier[2] = "dico_france-quebec.txt";
	Fichier[3] = "histoire_quebec.txt";
	Fichier[4] = "dico_ae.txt";
	//Fichier[5] = "dico.txt";
	
	
	for(u = 0; u < 6;u++)
	{
	    FILE * pFile;
	    pFile = fopen (Fichier[u],"r");
	    if (pFile==NULL)
	    {
		    printf("Erreur lors de l'ouverture du fichier\n");
		    exit(EXIT_FAILURE);
	    }
	    
	    cellule* c;
	    cellule* res;
	    list* l = creerListe();        
	    
	    clock_t debut = clock();
	    
	    int i = 0;
	    //rechercher un caracter
	    while(fscanf(pFile, "%s", T_FILE) != EOF)
	    {	
		    i++;
		    res = rechercher(T_FILE, l);
		    if(res == NULL)
		    {
			c = creerCellule(T_FILE);
			inserer(c,l);
		    }
	    }
	    debut = clock() - debut;
	    printf("Nom du fichier : %s\n",Fichier[u]);
	    printf("Nombre d'élément dans le fichier : %d\n",i);
	    printf("Nombre d'élément different dans la Liste : %d\n",compterListe(l));
	    printf("Pour trouver le nombre de mot différent il a fallu : %f seconde \n",(((float)debut)/CLOCKS_PER_SEC));
	    fclose (pFile);
	    detruireListe(l);
	  
	}
        
}
void question12()
{
  
	int m = 11; /////////////////////// definition de m
  
	char *T_FILE = malloc(sizeof(char)*256);//  <===============    
	char **Fichier = malloc(sizeof(char*)*6);
	int u;
	for(u = 0; u < 6;u++)
	  Fichier[u] = malloc(sizeof(char)*60);
	
	Fichier[0] = "texte1.txt";
	Fichier[1] = "texte2.txt";
	Fichier[2] = "dico_france-quebec.txt";
	Fichier[3] = "histoire_quebec.txt";
	Fichier[4] = "dico_ae.txt";
	//Fichier[5] = "dico.txt";
	
	
	for(u = 0; u < 6;u++)
	{
	    FILE * pFile;
	    pFile = fopen (Fichier[u],"r");
	    if (pFile==NULL)
	    {
		    printf("Erreur lors de l'ouverture du fichier\n");
		    exit(EXIT_FAILURE);
	    }
	    
	    cellule* c;
	    cellule* res;
	    hash* h = creerTableHachage(m);         
	    
	    clock_t debut = clock();
	    
	    int i = 0;
	    //rechercher un caracter
	    while(fscanf(pFile, "%s", T_FILE) != EOF)
	    {	
		    i++;
		    c = creerCellule(T_FILE);
		    res = rechercherHachage(T_FILE, h, convertirChEntier(T_FILE));
		    if(res == NULL)
		    {
			    insererHachage(h,convertirChEntier(c->mot), c);
		    }
	    }
	    debut = clock() - debut;
	    printf("Nom du fichier : %s\n",Fichier[u]);
	    printf("Nombre d'élément dans le fichier : %d\n",i);
	    printf("Nombre d'élément different dans la Liste : %d\n",compterTableHachage(h));
	    printf("Pour trouver le nombre de mot différent il a fallu : %f seconde \n",(((float)debut)/CLOCKS_PER_SEC));
	    fclose (pFile);
	    detruireTableHachage(h);
	  
	}
        
}
int main()
{
    //fonction vers la reponse de la question 4
    //question4();
  
    //fonction vers la reponse de la question 5
    //question5();
  
    // fonction vers la reponse de la question 6
    //question6();
  
    //fonction vers la reponse de la question 12
    question12();
    
    return 0;
}
