#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "cellule.h"
#include "liste.h"
#include "outilsListe.h"
#include "tableHachage.h"
#include "outilsTableHachage.h"

void afficherTableHachage(hash* h)
{
	int i;
	for(i = 0; i < h->taille; i++)
	{
		printf("================list %d =================\n", i);
		afficherListe(h->list[i]);
	}
}

unsigned long long convertirChEntier(const char* c)
{
	int i= 0;
	unsigned long long res = 0;
	while (c[i] != '\0')
	{
	 i++;
	}
	
	do{
		//printf("pow est %llu\n", (unsigned long long)pow(128, i-1));
		res += (int)c[i-1]*(unsigned long long)pow(128, i-1);
		i--;
	}while(i > 0);
	return res;
}

/* h(k)= k mod m; m est la taille dans hash */
int hachage(hash* h,unsigned long long k)
{
	return k%(h->taille);
}

void insererHachage(hash* h,unsigned long long k, cellule* c)
{
	inserer(c , h->list[hachage(h,k)]);//inserer dans la list
}

cellule* rechercherHachage(const char* str, hash* h, unsigned long long k)
{
	return rechercher(str, h->list[hachage(h,k)]);
}

void supprimerHachage(hash* h, cellule* c, unsigned long long k)
{
	supprimer(c, h->list[hachage(h ,k)]);
}

int recherSupri(const char* str, hash* h)
{
	unsigned long long k = convertirChEntier(str);
	cellule* var =  rechercherHachage(str, h, k);
	if(var != NULL)
	{
		supprimerHachage(h, var, k);
		return 1;
	}
	else
	{
		return 0;
	}
	
}

int compterTableHachage(hash* h)
{
	int i,compt =0;
	for(i = 0; i < h->taille; i++)
	{
		if(h->list[i]->debut != NULL)
		{
			cellule* precedent = h->list[i]->debut;
			while(precedent != NULL)
			{	
				compt++;
				precedent = precedent->next;
			}		
		}

	}
	return compt;			
}
